DT = LibStub("AceAddon-3.0"):NewAddon( "DT", "AceEvent-3.0", "AceConsole-3.0")
DT.date = string.sub("$Date: 2009-10-25 13:11:00 +0000 (Sun, 25 Oct 2009) $", 8, 17)
DT.revision = tonumber(string.sub("$Revision: 70 $", 12, -3))
DT.version = "v3.2-r" .. DT.revision

local AceLocale = LibStub("AceLocale-3.0")
local L = AceLocale:GetLocale( "DT" )
local width=0
local height=0
local t={}
local frames={}
function DT:OnInitialize()
	DT.db = LibStub("AceDB-3.0"):New("DeathTrackerDB")
	local defaults = 
	{
		profile = 
		{
			DetailWindowX = 200,
			DetailWindowY = -100,
			width=200,
			height=70,
			chan="RAID",
			locked=false,
			filter=
			{
				Player=true,
				inParty=false,
				inRaid=false,
				Trash=true,
			},
		},
	}
	DT.db:RegisterDefaults(defaults)
	DT.CreateGFrame()
  end

function DT:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function DT.CreateGFrame()
	local f = CreateFrame("Frame", nil, UIParent)
	f:SetWidth(DT.db.profile.width)
	f:SetHeight(DT.db.profile.height)
	f:SetPoint("TOPLEFT", UIParent, "TOPLEFT", DT.db.profile.DetailWindowX, DT.db.profile.DetailWindowY)
	f:EnableMouse(true)
	f:SetMovable(true)
	if DT.db.profile.locked==true then f.isLocked=1 end
	f:EnableMouseWheel(true)
	f:SetResizable(true)
	f:SetMinResize(190,30)
	f:SetMaxResize(800,800)		
	f:SetScript("OnMouseDown",function(self,button)
		if not self.isLocked then 
			self:StartMoving()
			self.isMoving = true
		end
	end)
	
	f:SetScript("OnMouseUp", function(self) 
		local point,relativeTo,relativePoint,xOfs,yOfs = this:GetPoint(1)
		DT.db.profile.DetailWindowX=xOfs
		DT.db.profile.DetailWindowY=yOfs
		self:StopMovingOrSizing()
		self.isMoving = false
		end
	)

	f.mTooltip = CreateFrame("GameTooltip", "mTooltip"	, f, "GameTooltipTemplate")
	
	local smf = CreateFrame("ScrollFrame", gsmf, f)
	smf:SetAllPoints()
	smf:SetPoint("TOPLEFT",f,"TOPLEFT",0,-15)
	smf:EnableMouseWheel(true)
	
		local scrollbar = CreateFrame("Slider",nil,smf,"UIPanelScrollBarTemplate")
	smf:SetScript("OnMouseWheel", function(self, arg1) 
		if arg1>0 then 
			scrollbar:SetValue(scrollbar:GetValue()-15)
		elseif arg1<0 then 
			scrollbar:SetValue(scrollbar:GetValue()+15)
		end 
		end
	)
	local scrollbg = scrollbar:CreateTexture(nil,"BACKGROUND")
		scrollbg:SetAllPoints(scrollbar)
		scrollbg:SetTexture(0,0,0,0.4)
		scrollbar:SetPoint("TOPLEFT",smf,"TOPRIGHT",4,-16)
		scrollbar:SetPoint("BOTTOMLEFT",smf,"BOTTOMRIGHT",4,16)
		scrollbar:SetMinMaxValues(0,0)
		scrollbar:SetValueStep(15)
		scrollbar:SetValue(0)
		scrollbar:SetWidth(5)
		scrollbar:Hide()
		smf.sb=scrollbar
		
		smf.cf=CreateFrame("Frame",nil,smf)
		smf.cf:SetWidth(190)
		smf.cf:SetHeight(0)
		smf:SetScrollChild(smf.cf)
		f.label1=f:CreateFontString(nil,"OVERLAY","GameFontNormal")
		f.label1:SetPoint("TOPLEFT",f,"TOPLEFT",0,0)
		f.label1:SetJustifyH("CENTER")
		f.label1:SetHeight(15)
		f.label1:SetWidth(30)
		f.label1:SetText("Time")
		f.label2=f:CreateFontString(nil,"OVERLAY","GameFontNormal")
		f.label2:SetPoint("TOPLEFT",f,"TOPLEFT",30,0)
		f.label2:SetJustifyH("CENTER")
		f.label2:SetHeight(15)
		f.label2:SetWidth(40)
		f.label2:SetText("Killer")
		f.label3=f:CreateFontString(nil,"OVERLAY","GameFontNormal")
		f.label3:SetPoint("TOPLEFT",f,"TOPLEFT",70,0)
		f.label3:SetJustifyH("CENTER")
		f.label3:SetHeight(15)
		f.label3:SetWidth(40)
		f.label3:SetText("Killed")
		f.label4=f:CreateFontString(nil,"OVERLAY","GameFontNormal")
		f.label4:SetPoint("TOPLEFT",f,"TOPLEFT",110,0)
		f.label4:SetJustifyH("CENTER")
		f.label4:SetHeight(15)
		f.label4:SetWidth(40)
		f.label4:SetText("Skill")
		f.label5=f:CreateFontString(nil,"OVERLAY","GameFontNormal")
		f.label5:SetPoint("TOPLEFT",f,"TOPLEFT",150,0)
		f.label5:SetJustifyH("CENTER")
		f.label5:SetHeight(15)
		f.label5:SetWidth(40)
		f.label5:SetText("Dmg")
	f.frame=smf
	f.help=CreateFrame("Frame",nil,UIParent)
	f.help:SetWidth(200)
	f.help:SetHeight(100)
	f.help:SetPoint("CENTER",UIParent,"CENTER")
	f.help.text=f.help:CreateFontString(nil,"OVERLAY","GameFontNormal")
	f.help.text:SetJustifyH("CENTER")
	f.help.text:SetHeight(100)
	f.help.text:SetWidth(200)
	f.help.text:SetText("|cFFFFFFFFHELP\n\n|cFF00FF00Shift-click on line to paste it in chat\n\nScrolling with mouse wheel")
	f.help.text:SetPoint("TOPLEFT",f.help,"TOPLEFT")
--	f.help.text:SetPoint("RIGHT",f.help,"RIGHT")
	f.help.bg = f.help:CreateTexture(nil, "BACKGROUND")
	f.help.bg:SetTexture(0, 0, 0, 0.7)
	f.help.bg:SetPoint("TOPLEFT", f.help, "TOPLEFT", -2, 0)
	f.help.bg:SetPoint("BOTTOMRIGHT", f.help, "BOTTOMRIGHT", 2, -2)
	f.help.but=CreateFrame("Button","bt",f.help,"UIPanelButtonTemplate2")
	f.help.but:SetText("Ok")
	f.help.but:SetScript("OnClick",function(ss) 
		ss:GetParent():Hide()
	end)
	f.help.but:SetPoint("BOTTOM",f.help,"BOTTOM")
	f.help:Hide()
	
	local bg = f:CreateTexture(nil, "BACKGROUND")
	bg:SetTexture(0, 0, 0, 0.7)
	bg:SetPoint("TOPLEFT", f, "TOPLEFT", -2, 0)
	bg:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 2, -2)

	local dm = CreateFrame("Frame", "DropDownMenu")
	dm.displayMode = "MENU"
	dm.info = {}
	dm.UncheckHack = function(dropdownbutton)
		_G[dropdownbutton:GetName().."Check"]:Hide()
	end
	dm.HideMenu = function()
		if UIDROPDOWNMENU_OPEN_MENU == ExampleDropDownMenu then
			CloseDropDownMenus()
		end
	end
	dm.initialize = DT.Menu
	f.dm=dm
	
	f.cb=CreateFrame("Button","Config",f)
	f.cb:Show()
	f.cb:SetNormalTexture("Interface\\Addons\\Death_Tracker\\Icons\\config")
	f.cb:SetHighlightTexture("Interface\\Addons\\Death_Tracker\\Icons\\config")
	f.cb:SetWidth(16)
	f.cb:SetHeight(16)
	f.cb:SetPoint("TOPRIGHT",f,"TOPRIGHT",0,0)
	f.cb:SetScript("OnClick", function(self, button, down)
			ToggleDropDownMenu(1, nil, dm, self, 0, 0)
	end)
	f.cb:SetFrameLevel(f.cb:GetFrameLevel()+2)
	f.cb:RegisterForClicks("RightButtonUp","LeftButtonUp")

	
	f.DragBottomRight = CreateFrame("Button", "RecountResizeGripRight", f) 
	f.DragBottomRight:Show()
	f.DragBottomRight:SetFrameLevel( f:GetFrameLevel() + 10)
	f.DragBottomRight:SetNormalTexture("Interface\\AddOns\\Death_Tracker\\icons\\ResizeGripRight")
	f.DragBottomRight:SetHighlightTexture("Interface\\AddOns\\Death_Tracker\\icons\\ResizeGripRight")
	f.DragBottomRight:SetWidth(16)
	f.DragBottomRight:SetHeight(16)
	f.DragBottomRight:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 0, 0)
	f.DragBottomRight:EnableMouse(true)
	f.DragBottomRight:SetScript("OnMouseDown", function(self,button) if (not self:GetParent().isLocked  ) then self:GetParent().isResizing = true; self:GetParent():StartSizing("BOTTOMRIGHT") end end ) 
	f.DragBottomRight:SetScript("OnMouseUp", function(self,button) if self:GetParent().isResizing == true then self:GetParent():StopMovingOrSizing();
	DT.db.profile.width=self:GetParent():GetWidth();DT.db.profile.height=self:GetParent():GetHeight();
	self:GetParent().isResizing = false; end end )


	gfrm, frs ,frc= f, f.frame,smf.cf
	
	f=nil

end

function DT.Menu(self, level)
	if not level then return end
	local info = self.info
	wipe(info)
	if level == 1 then
		info.isTitle = 1
		info.text = "Filter"
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		
		info.keepShownOnClick = 1
		info.disabled = nil
		info.isTitle = nil
		info.notCheckable = nil
		info.text = "Show Deaths"
		info.func = self.UncheckHack
		info.hasArrow = 1
		info.value = "submenu1"
		UIDropDownMenu_AddButton(info, level)
		
		info.keepShownOnClick = 1
		info.disabled = nil
		info.isTitle = nil
		info.notCheckable = nil
		info.text = "Report Channel"
		info.func = self.UncheckHack
		info.hasArrow = 1
		info.value = "submenu2"
		UIDropDownMenu_AddButton(info, level)
		
		info.text = "Lock"
		info.keepShownOnClick = 1
		info.hasArrow = nil
		value="Lock"
		info.disabled = nil
		info.notCheckable=nil
		info.checked = function() return (DT.db.profile.locked or nil) end
		info.func=function() 
			if DT.db.profile.locked==true then 
				DT.db.profile.locked=false
			else 
				DT.db.profile.locked=true
			end
			gfrm.isLocked=DT.db.profile.locked
		end
		UIDropDownMenu_AddButton(info, level)
		info.text = "Clear"
			info.keepShownOnClick = 1
			info.hasArrow = nil
			value="Clear"
			info.disabled = nil
			info.notCheckable=nil
			info.checked = nil
			info.func=function(self) 
				DT.Clear()
				gfrm.dm.UncheckHack(self)
			end
			UIDropDownMenu_AddButton(info, level)
		info.text = "Help"
			info.keepShownOnClick = 1
			info.hasArrow = nil
			value="Help"
			info.disabled = nil
			info.notCheckable=nil
			info.checked = nil
			info.func=function(self) 
				gfrm.help:Show()
				gfrm.dm.UncheckHack(self)
			end
			UIDropDownMenu_AddButton(info, level)
	elseif level == 2 then
		if UIDROPDOWNMENU_MENU_VALUE == "submenu1" then
			info.text = "Player"
			info.keepShownOnClick = 1
			info.hasArrow = 1
			value="Player"
			info.disabled = nil
			info.notCheckable=nil
			info.checked = function() return (DT.db.profile.filter.Player or nil) end
			info.func=function() 
				if DT.db.profile.filter.Player then 
					DT.db.profile.filter.Player=false
				else 
					DT.db.profile.filter.Player=true
				end
			end
			UIDropDownMenu_AddButton(info, level)
			info.text = "Trash"
			info.keepShownOnClick = 1
			info.hasArrow = nil
			value="Trash"
			info.disabled = nil
			info.notCheckable=nil
			info.checked = function() return (DT.db.profile.filter.Trash or nil) end
			info.func=function() 
				if DT.db.profile.filter.Trash then 
					DT.db.profile.filter.Trash=false
				else 
					DT.db.profile.filter.Trash=true
				end
			end
			UIDropDownMenu_AddButton(info, level)
		elseif UIDROPDOWNMENU_MENU_VALUE == "submenu2" then
			info.text = "Say"
			info.checked = function() 
				if DT.db.profile.chan=="SAY"  then
					return 1 
				else 
					return nil 
				end 
			end
			info.func=function() DT.db.profile.chan="SAY" end
			UIDropDownMenu_AddButton(info, level)

			info.text = "Party"
			info.func=function() DT.db.profile.chan="PARTY" end
			info.checked = function() 
				if DT.db.profile.chan=="PARTY"  then
					return 1 
				else 
					return nil 
				end 
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Guild"
			info.func=function() DT.db.profile.chan="GUILD" end
			info.checked = function() 
				if DT.db.profile.chan=="GUILD"  then
					return 1 
				else 
					return nil 
				end 
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Officer"
			info.func=function() DT.db.profile.chan="OFFICER" end
			info.checked = function() 
				if DT.db.profile.chan=="OFFICER"  then
					return 1 
				else 
					return nil 
				end 
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Raid"
			info.func=function() DT.db.profile.chan="RAID" end
			info.checked = function() 
				if DT.db.profile.chan=="RAID"  then
					return 1 
				else 
					return nil 
				end 
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Raid warning"
			info.func=function() DT.db.profile.chan="RAID_WARNING" end
			info.checked = function() 
				if DT.db.profile.chan=="RAID_WARNING"  then
					return 1 
				else 
					return nil 
				end 
			end
			UIDropDownMenu_AddButton(info, level)
		end
	elseif level == 3 then
		if UIDROPDOWNMENU_MENU_VALUE == "Player" then
			info.text = "Only In Party"
			info.keepShownOnClick = 1
			info.disabled = nil
			info.notCheckable=nil
			info.checked = function() return (DT.db.profile.filter.inParty or nil) end
			info.func=function() 
				if DT.db.profile.filter.inParty then 
					DT.db.profile.filter.inParty=false
				else 
					DT.db.profile.filter.inParty=true
					DT.db.profile.filter.inRaid=false
				end
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Only In Raid"
			info.keepShownOnClick = 1
			info.disabled = nil
			info.notCheckable=nil
			info.checked = function() return (DT.db.profile.filter.inRaid or nil) end
			info.func=function() 
				if DT.db.profile.filter.inRaid then 
					DT.db.profile.filter.inRaid=false
				else 
					DT.db.profile.filter.inRaid=true
					DT.db.profile.filter.inParty=false
				end
			end
			UIDropDownMenu_AddButton(info, level)
		end
	end
end

local subevents = { SPELL_DAMAGE = true, SPELL_PERIODIC_DAMAGE = true, RANGE_DAMAGE = true }
local count, now, prev = 0, 0, 0
local candidates = {}
local mflag=0
local tstamp, slink, dtype, src, spellID, spellName, spellSchool, amount, crit, crush, eType, overkill
function DT.Clear()
	local i
	if table.getn(frames)>0 then
		for i =0,(table.getn(frames)) do
			frames[i]:ClearAllPoints() 
			frames[i]:Hide() 
			frames[i]=nil 
			mflag=0
		end
	end
	t=nil
	t={}
end
function DT.Zapo()
	local i=0
	local row1=0
	local row2=0
	local row3=0
	local row4=0
	local row5=0
	local label
	
	for _, data in ipairs(t) do
		if mflag~=0 and count>i then frames[i]:ClearAllPoints() frames[i]:Hide() frames[i]=nil end
		frames[i]=CreateFrame("Frame",nil,frs.cf) 
		frames[i]:SetPoint("TOPLEFT",frs.cf,"TOPLEFT",0,-(i*15))
		frames[i]:SetHeight(15)
		frames[i]:EnableMouse(true)
		frames[i].qw="DT: "..data.tm.." "..data.src.."->"..data.dst.." "..L["with"].." "..data.skill.." "..L["dmg"]..":"..data.dmg
		frames[i]:SetWidth(100)
		frames[i]:SetScript("OnMouseDown",function(ss) 
			if (IsShiftKeyDown()) then
				SendChatMessage(ss.qw, DT.db.profile.chan, nil, GetChannelName("cname")) 
			else
				if ss.skill~=0 then
					gfrm.mTooltip:SetOwner(gfrm, "ANCHOR_TOPRIGHT")
					gfrm.mTooltip:SetHyperlink(ss.skill)
					gfrm.mTooltip:Show()
				end
			end
		end)
		frames[i]:SetScript("OnLeave",function(ss) 
			gfrm.mTooltip:Hide()
		end)
		label=frames[i]:CreateFontString(nil,"OVERLAY","GameFontNormal")
		label:SetPoint("TOPLEFT",frames[i],"TOPLEFT",0,0)
		label:SetJustifyH("LEFT")
		label:SetHeight(15)
		label:SetText("|cFFD2D2D2"..data.tm)
		if row1<label:GetWidth() then row1=label:GetWidth() end
		i=i+1
	end
	gfrm.label1:SetWidth(row1)
	gfrm.label2:SetPoint("TOPLEFT",gfrm,"TOPLEFT",row1,0)
	count=i
	i=0
	mflag=1
	for _, data in ipairs(t) do
		label=frames[i]:CreateFontString(nil,"OVERLAY","GameFontNormal")
		label:SetPoint("TOPLEFT",frames[i],"TOPLEFT",row1,0)
		label:SetJustifyH("LEFT")
		label:SetHeight(15)
		label:SetText(data.csrc..data.src)
		if row2<label:GetWidth() then row2=label:GetWidth() end
		i=i+1
	end
	gfrm.label2:SetWidth(row2)
	gfrm.label3:SetPoint("TOPLEFT",gfrm,"TOPLEFT",row1+row2,0)
	i=0
	for _, data in ipairs(t) do
		label=frames[i]:CreateFontString(nil,"OVERLAY","GameFontNormal")
		label:SetPoint("TOPLEFT",frames[i],"TOPLEFT",row1+row2,0)
		label:SetJustifyH("LEFT")
		label:SetHeight(15)
		label:SetText(data.cdst..data.dst)
		if row3<label:GetWidth() then row3=label:GetWidth() end
		i=i+1
	end
	gfrm.label3:SetWidth(row3)
	gfrm.label4:SetPoint("TOPLEFT",gfrm,"TOPLEFT",row1+row2+row3,0)
	i=0
	for _, data in ipairs(t) do
		label=frames[i]:CreateFontString(nil,"OVERLAY","GameFontNormal")
		label:SetPoint("TOPLEFT",frames[i],"TOPLEFT",row1+row2+row3,0)
		label:SetJustifyH("LEFT")
		label:SetHeight(15)
		label:SetText(data.skill)
		if data.skill~="Meele" then
			frames[i].skill=data.skill
		else
			frames[i].skill=0
		end
		if row4<label:GetWidth() then row4=label:GetWidth() end
		i=i+1
	end
	gfrm.label4:SetWidth(row4)
	gfrm.label5:SetPoint("TOPLEFT",gfrm,"TOPLEFT",row1+row2+row3+row4,0)
	i=0
	for _, data in ipairs(t) do
		label=frames[i]:CreateFontString(nil,"OVERLAY","GameFontNormal")
		label:SetPoint("TOPLEFT",frames[i],"TOPLEFT",row1+row2+row3+row4,0)
		label:SetJustifyH("LEFT")
		label:SetHeight(15)
		label:SetText(data.dmg)
		if row5<label:GetWidth() then row5=label:GetWidth() end
		i=i+1
	end
	gfrm.label5:SetWidth(row5)
	width=row1+row2+row3+row4+row5
	local a
	for a=0,i-1 do
		frames[a]:SetWidth(width)
	end
	frs.cf:SetWidth(width)
	gfrm:SetMinResize(width,30)
	frs.cf:SetHeight(i*15)
	frs.sb:SetMinMaxValues(0,(i-1)*15)
	frs.sb:SetValue((i+1)*15-gfrm:GetHeight())
end

function DT.output(text, critical, pet, prefix)
	local frame =1
	local t = (pet and "[" or "").. (critical and "*" or "")..  text.. (critical and "*" or "")..  (pet and "]" or "")
	frs:AddMessage(t)
end

function DT:COMBAT_LOG_EVENT_UNFILTERED(event,timestamp, subevent, srcGUID, srcName, srcFlags, destGUID, destName, destFlags, ...)
		local csrc=""
		local cdst=""
		if not DT.db.profile.filter.Player then
			if UnitIsPlayer(destName) then return end
		end
		if not DT.db.profile.filter.Trash then
			if not UnitIsPlayer(destName) then return end
		end
		if UnitIsPlayer("DestName") then
			if DT.db.profile.filter.inRaid then
				if not UnitInRaid(destName) then return end
			end
			if DT.db.profile.filter.inParty then
				if not UnutInParty(destName) then return end
			end
		end


		now = GetTime()
	tstamp = date("%X")
			src = srcName or "Unknown"
			if  UnitIsPlayer(src) then csrc="|cFF00FF00" else csrc="|cFFFF0000" end
			if destName then if  UnitIsPlayer(destName) then cdst="|cFF00FF00" else cdst="|cFFFF0000" end end
	if subevents[subevent] then
	spellID, spellName, spellSchool, amount, overkill, _, _, _, _, crit, _, crush = ...
		if amount > 0 then
			slink = GetSpellLink(spellID)
			dtype = (crit and " ("..L["Critical"]..")") or (crush and " ("..L["Crushing"]..")") or ""
			candidates[destGUID] = {tm=tstamp,csrc=csrc,src=src,cdst=cdst,dst=destName,skill=slink,dmg=amount..dtype}
		end
	elseif subevent == "SWING_DAMAGE" then
	amount, overkill, _, _, _, _, crit, _, crush = ...
		if amount > 0 then
			dtype = (crit and " ("..L["Critical"]..")") or (crush and " ("..L["Crushing"]..")") or ""
			candidates[destGUID] = {tm=tstamp,csrc=csrc,src=src,cdst=cdst,dst=destName,skill="Meele",dmg=amount..dtype}
		end
	elseif subevent == "SPELL_INSTAKILL" then
		spellID = ...
		slink = GetSpellLink(spellID)
		candidates[destGUID] = {tm=tstamp,csrc=csrc,src="",cdst=cdst,dst=destName,skill=slink,dmg=""}
	elseif subevent == "ENVIRONMENTAL_DAMAGE" then
		eType, amount = ...
		src = srcName or "Unknown"
		candidates[destGUID] = {tm=tstamp,csrc=csrc,src=src,cdst=cdst,dst=destName,skill=eType,dmg=amount}
	end
	
	if subevent == "UNIT_DIED" then
		if not UnitIsFeignDeath(destName) then
			if candidates[destGUID]  then 
				table.insert(t,candidates[destGUID])
				candidates[destGUID] = nil
				prev = now
				DT.Zapo()
			end
		end
	end

end
